#version 400
layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;
in vec3 teNormal[3];
in vec2 teTexcoord[3];
in vec4 tePosition[3];
out vec3 gsNormal;
out vec2 gsTexcoord;

uniform int RecalcNormals;
void main(){
if(RecalcNormals == 2)
{
    vec3 A = tePosition[2].xyz - tePosition[0].xyz;
    vec3 B = tePosition[1].xyz - tePosition[0].xyz;
    gsNormal = normalize(cross(A, B));
}

    gsTexcoord = teTexcoord[0];
    gl_Position = tePosition[0]; 
if(RecalcNormals != 2)
{
    gsNormal = teNormal[0];
}    
		EmitVertex();
		

    gsTexcoord = teTexcoord[1];
    gl_Position = tePosition[1]; 
if(RecalcNormals != 2)
{
    gsNormal = teNormal[1];
}        
		EmitVertex();

    gsTexcoord = teTexcoord[2];
    gl_Position = tePosition[2]; 
if(RecalcNormals != 2)
{
    gsNormal = teNormal[2];
}        
		EmitVertex();
    EndPrimitive();
}